#include <iostream>
#include <algorithm>
#include "nodeattr.hh"

NodeAttr::NodeAttr(vertex_set_t & _z, indeg_t & _indeg, vertex_set_t & _alive)
	: z(_z), indeg(_indeg), alive(_alive)
{
}


NodeAttr::~NodeAttr()
{
}

bool NodeAttr::operator==(const NodeAttr & _node_attr) const
{
  return this == & _node_attr;
}

/*
void NodeAttr::print(void)
{
	//Debug
	std::cout << "Z_0 = { ";
	std::copy(z.begin(), z.end(), 
		std::ostream_iterator< vertex_id >(std::cout, " "));
	std::cout << "}\nIndeg = {";
	for(indeg_t::iterator ii = indeg.begin(); ii != indeg.end(); ++ii) {
		std::cout << " (" << ii->first << "," << ii->second << ")";
	}
	std::cout << " }\nAlive = { ";
	std::copy(alive.begin(), alive.end(),
		std::ostream_iterator< vertex_id >(std::cout, " "));
	std::cout << "}\n";
}
*/

std::ostream & operator<<(std::ostream & _out, const NodeAttr & _node_attr)
{
  _out << "z_0 = { ";
  std::copy(_node_attr.z.begin(), _node_attr.z.end(), 
	    std::ostream_iterator< vertex_id >(_out, " "));

  indeg_t indeg = _node_attr.indeg;
  indeg_t::iterator  ii = indeg.begin(), ii_end = indeg.end();

  _out << "}\nindeg = {";
  for(; ii != ii_end; ++ii) {
    _out << " (" << ii->first << "," << ii->second << ")";
  }

  _out << " }\nalive = { ";
  std::copy(_node_attr.alive.begin(), _node_attr.alive.end(),
	    std::ostream_iterator< vertex_id >(_out, " "));
  _out << "}\n";

  return _out;
}
								
