%{
#include "c.h"
#include "time.h"
#define debug2(x) //(void)(xflag&&((x),0))
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address(Symbol, Symbol, long);
static void blkfetch(int, int, int, int);
static void blkloop(int, int, int, int, int, int[]);
static void blkstore(int, int, int, int);
static void defaddress(Symbol);
static void defconst(int, int, Value);
static void defstring(int, char *);
static void defsymbol(Symbol);
static void doarg(Node);
static void emit2(Node);
static void export(Symbol);
static void clobber(Node);
static void function(Symbol, Symbol [], Symbol [], int);
static void global(Symbol);
static void import(Symbol);
static void local(Symbol);
static void progbeg(int, char **);
static void progend(void);
static void segment(int);
static void space(int);
static void target(Node);
static int equal(Node p, int a);
static Symbol ireg[32], ireg2[32], areg[32], areg2[32];
static Symbol rreg[32];
static Symbol iregw, ireg2w, aregw, areg2w;
static Symbol rregw;
static int cseg;
static int retstruct;
%}
%start stmt
%term CNSTF1=1041 CNSTF2=2065
%term CNSTI1=1045 CNSTI2=2069
%term CNSTP1=1047
%term CNSTU1=1046 CNSTU2=2070
%term ARGB=41
%term ARGF1=1057 ARGF2=2081
%term ARGI1=1061 ARGI2=2085
%term ARGP1=1063
%term ARGU1=1062 ARGU2=2086
%term ASGNB=57
%term ASGNF1=1073 ASGNF2=2097
%term ASGNI1=1077 ASGNI2=2101
%term ASGNP1=1079
%term ASGNU1=1078 ASGNU2=2102
%term INDIRB=73
%term INDIRF1=1089 INDIRF2=2113
%term INDIRI1=1093 INDIRI2=2117
%term INDIRP1=1095
%term INDIRU1=1094 INDIRU2=2118
%term CVFF1=1137 CVFF2=2161
%term CVFI1=1141 CVFI2=2165
%term CVIF1=1153 CVIF2=2177
%term CVII1=1157 CVII2=2181
%term CVIU1=1158 CVIU2=2182
%term CVPU1=1174
%term CVUI1=1205 CVUI2=2229
%term CVUP1=1207
%term CVUU1=1206 CVUU2=2230
%term NEGF1=1217 NEGF2=2241
%term NEGI1=1221 NEGI2=2245
%term CALLB=217
%term CALLF1=1233 CALLF2=2257
%term CALLI1=1237 CALLI2=2261
%term CALLP1=1239
%term CALLU1=1238 CALLU2=2262
%term CALLV=216
%term RETF1=1265 RETF2=2289
%term RETI1=1269 RETI2=2293
%term RETP1=1271
%term RETU1=1270 RETU2=2294
%term RETV=248
%term ADDRGP1=1287
%term ADDRFP1=1303
%term ADDRLP1=1319
%term ADDF1=1329 ADDF2=2353
%term ADDI1=1333 ADDI2=2357
%term ADDP1=1335
%term ADDU1=1334 ADDU2=2358
%term SUBF1=1345 SUBF2=2369
%term SUBI1=1349 SUBI2=2373
%term SUBP1=1351
%term SUBU1=1350 SUBU2=2374
%term LSHI1=1365 LSHI2=2389
%term LSHU1=1366 LSHU2=2390
%term MODI1=1381 MODI2=2405
%term MODU1=1382 MODU2=2406
%term RSHI1=1397 RSHI2=2421
%term RSHU1=1398 RSHU2=2422
%term BANDI1=1413 BANDI2=2437
%term BANDU1=1414 BANDU2=2438
%term BCOMI1=1429 BCOMI2=2453
%term BCOMU1=1430 BCOMU2=2454
%term BORI1=1445 BORI2=2469
%term BORU1=1446 BORU2=2470
%term BXORI1=1461 BXORI2=2485
%term BXORU1=1462 BXORU2=2486
%term DIVF1=1473 DIVF2=2497
%term DIVI1=1477 DIVI2=2501
%term DIVU1=1478 DIVU2=2502
%term MULF1=1489 MULF2=2513
%term MULI1=1493 MULI2=2517
%term MULU1=1494 MULU2=2518
%term EQF1=1505 EQF2=2529
%term EQI1=1509 EQI2=2533
%term EQU1=1510 EQU2=2534
%term GEF1=1521 GEF2=2545
%term GEI1=1525 GEI2=2549
%term GEU1=1526 GEU2=2550
%term GTF1=1537 GTF2=2561
%term GTI1=1541 GTI2=2565
%term GTU1=1542 GTU2=2566
%term LEF1=1553 LEF2=2577
%term LEI1=1557 LEI2=2581
%term LEU1=1558 LEU2=2582
%term LTF1=1569 LTF2=2593
%term LTI1=1573 LTI2=2597
%term LTU1=1574 LTU2=2598
%term NEF1=1585 NEF2=2609
%term NEI1=1589 NEI2=2613
%term NEU1=1590 NEU2=2614
%term JUMPV=584
%term LABELV=600
%term VREGP=711
%term LOADI1=1253
%term LOADI2=2277
%term LOADU1=1254
%term LOADU2=2278
%term LOADB=233
%term LOADF1=1249
%term LOADF2=2273
%term LOADP1=1255
%%
reg: INDIRI1(VREGP) "# read register\n"
reg: INDIRI2(VREGP) "# read register\n"
reg: INDIRU1(VREGP) "# read register\n"
reg: INDIRU2(VREGP) "# read register\n"
reg: INDIRF1(VREGP) "# read register\n"
reg: INDIRF2(VREGP) "# read register\n"
rreg: INDIRP1(VREGP) "# read register\n"
stmt: ASGNI1(VREGP, reg) "# write register\n"
stmt: ASGNI2(VREGP, reg) "# write register\n"
stmt: ASGNU1(VREGP, reg) "# write register\n"
stmt: ASGNU2(VREGP, reg) "# write register\n"
stmt: ASGNF1(VREGP, reg) "# write register\n"
stmt: ASGNF2(VREGP, reg) "# write register\n"
stmt: ASGNP1(VREGP, rreg) "# write register\n"
con: CNSTI1 "%a"
reg: CNSTI2 "# \tmove \t#>%a,%c\n" 2+2
con: CNSTU1 "%a"
reg: CNSTU2 "# \tmove \t#>%a,%c\n" 2+2
con: CNSTP1 "%a"
reg: CNSTF1 "# \tmove \t#>%a,%c\n" 2
reg: CNSTF2 "# \tmove \t#>%a,%c\n" 2+2
reg: LOADI1(reg) "\tmove \t%0,%c\n" 2
reg: LOADU1(reg) "\tmove \t%0,%c\n" 2
reg: LOADU1(rreg) "\tmove \t%0,%c\n" 2
reg: LOADI2(reg) "# \tmove \t%0,%c\n" 2
reg: LOADU2(reg) "# \tmove \t%0,%c\n" 2
reg: LOADF1(reg) "\tmove \t%0,%c\n" 2
reg: LOADF2(reg) "# \tmove \t%0,%c\n" 2
rreg: LOADP1(rreg) "\tmove \t%0,%c\n" 2
rreg: LOADP1(reg) "\tmove \t%0,%c\n" 2
reg: con "\tmove \t#>%0,%c\n" 2
rreg: con "\tmove \t#%0,%c\n" 2
rreg: ADDRGP1 "\tmove \t#%a,%c\n" 2
rreg: ADDRFP1 "\tmove \t#%a,n0\n\tlua \t(r0)+n0,%c\n" 2+4
rreg: ADDRLP1 "\tmove \t#%a,n6\n\tlua \t(r6)+n6,%c\n" 2+4
stmt: reg ""
stmt: LABELV "%a:\n"
addr: rreg "Y:(%0)"
addr: ADDRGP1 "Y:%a"
stmt: ASGNI1(addr, reg) "\tmove \t%1,%0\n" 2
stmt: ASGNI2(addr, reg) "# \tmove \t%1,%0\n" 2
stmt: ASGNU1(addr, reg) "\tmove \t%1,%0\n" 2
stmt: ASGNU2(addr, reg) "# \tmove \t%1,%0\n" 2
stmt: ASGNF1(addr, reg) "\tmove \t%1,%0\n" 2
stmt: ASGNF2(addr, reg) "# \tmove \t%1,%0\n" 2
stmt: ASGNP1(addr, rreg) "\tmove \t%1,%0\n" 2
stmt: ASGNB(rreg, INDIRB(rreg)) "# ASGNB\n"
reg: INDIRI1(addr) "\tmove \t%0,%c\n" 2
reg: INDIRI2(addr) "# \tmove \t%0,%c\n" 2
reg: INDIRU1(addr) "\tmove \t%0,%c\n" 2
reg: INDIRU2(addr) "# \tmove \t%0,%c\n" 2
reg: INDIRF1(addr) "\tmove \t%0,%c\n" 2
reg: INDIRF2(addr) "# \tmove \t%0,%c\n" 2
rreg: INDIRP1(addr) "\tmove \t%0,%c\n" 2
reg: ADDI1(reg, reg) "\tadd \t%1,%0\n" 2
reg: ADDI2(reg, reg) "\tadd \t%1,%0\n" 2
reg: ADDU1(reg, reg) "\tadd \t%1,%0\n" 2
reg: ADDU2(reg, reg) "\tadd \t%1,%0\n" 2
reg: ADDF1(reg, reg) "\tadd \t%1,%0\n" 2
reg: ADDF2(reg, reg) "\tadd \t%1,%0\n" 2
reg: SUBI1(reg, reg) "\tsub \t%1,%0\n" 2
reg: SUBI2(reg, reg) "\tsub \t%1,%0\n" 2
reg: SUBU1(reg, reg) "\tsub \t%1,%0\n" 2
reg: SUBU2(reg, reg) "\tsub \t%1,%0\n" 2
reg: SUBF1(reg, reg) "\tsub \t%1,%0\n" 2
reg: SUBF2(reg, reg) "\tsub \t%1,%0\n" 2
rc: reg "%0"
rc: con "%#%0"
rreg: ADDP1(rc, rreg) "# \tmove \t%0,n8\n\tlua \t(%1)+n8,%c\n" 2+4
rreg: ADDP1(rreg, rc) "# \tmove \t%1,n8\n\tlua \t(%0)+n8,%c\n" 2+4
rreg: SUBP1(rc, rreg) "# \tmove \t%0,n8\n\tlua \t(%1)-n8,%c\n" 2+4
rreg: SUBP1(rreg, rc) "# \tmove \t%1,n8\n\tlua \t(%0)-n8,%c\n" 2+4
rreg: MULI1(reg, reg) "# \tmpy \t%0,%1,%c\n\tasr \t%c\n\tmove \t%c0,%c\n" 2+2+2
rreg: MULI2(reg, reg) "# \tmpy \t%0,%1,%c\n" 2
rreg: MULU1(reg, reg) "# \tmpy \t%0,%1,%c\n\tasr \t%c\n\tmove \t%c0,%c\n" 2+2+2
reg: MULU2(reg, reg) "# \tmpy \t%0,%1,%c\n" 2
reg: MULF1(reg, reg) "# \tmpy \t%0,%1,%c\n\tmove \t%c0,%c\n" 2+2
reg: MULF2(reg, reg) "# \tmpy \t%0,%1,%c\n" 2
reg: DIVI1(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: DIVI2(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: DIVU1(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: DIVU2(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: DIVF1(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: DIVF2(reg, reg) "# \tdiv \t%0,%1\n" 2
reg: MODI1(reg, reg) "# \tmod \t%0,%1\n" 2
reg: MODI2(reg, reg) "# \tmod \t%0,%1\n" 2
reg: MODU1(reg, reg) "# \tmod \t%0,%1\n" 2
reg: MODU2(reg, reg) "# \tmod \t%0,%1\n" 2
reg: CVII1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVII2(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVIU1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVIU2(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVIF1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVIF2(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVUI1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVUI2(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVUU1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVUU2(reg) "# \tmove \t%0,%c\n" move(a)
rreg: CVUP1(reg) "\tmove \t%0,%c\n" move(a)
reg: CVPU1(rreg) "\tmove \t%0,%c\n" move(a)
reg: CVFF1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVFF2(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVFI1(reg) "# \tmove \t%0,%c\n" move(a)
reg: CVFI2(reg) "# \tmove \t%0,%c\n" move(a)
stmt: JUMPV(jaddr) "\tjmp \t%0\n" 4
reg: CALLB(jaddr, rreg) "\tmove \t%1,%c\n\tjsr \t%0\n" 2+4
reg: CALLI1(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLI1(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLI1(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLI2(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLI2(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLI2(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLP1(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLP1(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLP1(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLU1(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLU1(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLU1(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLU2(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLU2(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLU2(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLF1(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLF1(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLF1(jaddr) "\tjsr \t%0\n" equal(a, 0)
reg: CALLF2(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
reg: CALLF2(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
reg: CALLF2(jaddr) "\tjsr \t%0\n" equal(a, 0)
stmt: CALLV(jaddr) "\tjsr \t%0\n\tmove \t#%a,n6\n\tmove \t(r6)-n6\n" 4+2
stmt: CALLV(jaddr) "\tjsr \t%0\n\tmove \t(r6)-\n" equal(a, 1)
stmt: CALLV(jaddr) "\tjsr \t%0\n" equal(a, 0)
jaddr: ADDRGP1 "%a"
jaddr: CNSTP1 "%a"
jaddr: rreg "(%0)"
stmt: ARGI1(reg) "\tmove \t%0,Y:(r6)+\n" 2
stmt: ARGI2(reg) "# \tmove \t%0,Y:(r6)+\n" 2
stmt: ARGU1(reg) "\tmove \t%0,Y:(r6)+\n" 2
stmt: ARGU2(reg) "# \tmove \t%0,Y:(r6)+\n" 2
stmt: ARGF1(reg) "\tmove \t%0,Y:(r6)+\n" 2
stmt: ARGF2(reg) "# \tmove \t%0,Y:(r6)+\n" 2
stmt: ARGP1(rreg) "\tmove \t%0,Y:(r6)+\n" 2
stmt: ARGB(INDIRB(rreg)) "# ARGB\n" 8
stmt: RETI1(reg) "# rts\n" 4
stmt: RETI2(reg) "# rts\n" 4
stmt: RETU1(reg) "# rts\n" 4
stmt: RETU2(reg) "# rts\n" 4
stmt: RETF1(reg) "# rts\n" 4
stmt: RETF2(reg) "# rts\n" 4
stmt: RETP1(rreg) "# rts\n" 4
stmt: EQI1(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: EQI2(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: EQU1(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: EQU2(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: EQF1(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: EQF2(reg, reg) "\tcmp \t%1,%0\n\tjeq \t%a\n" 2+4
stmt: GEI1(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GEI2(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GEU1(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GEU2(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GEF1(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GEF2(reg, reg) "\tcmp \t%1,%0\n\tjge \t%a\n" 2+4
stmt: GTI1(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: GTI2(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: GTU1(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: GTU2(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: GTF1(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: GTF2(reg, reg) "\tcmp \t%1,%0\n\tjgt \t%a\n" 2+4
stmt: LEI1(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LEI2(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LEU1(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LEU2(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LEF1(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LEF2(reg, reg) "\tcmp \t%1,%0\n\tjle \t%a\n" 2+4
stmt: LTI1(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: LTI2(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: LTU1(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: LTU2(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: LTF1(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: LTF2(reg, reg) "\tcmp \t%1,%0\n\tjlt \t%a\n" 2+4
stmt: NEI1(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
stmt: NEI2(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
stmt: NEU1(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
stmt: NEU2(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
stmt: NEF1(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
stmt: NEF2(reg, reg) "\tcmp \t%1,%0\n\tjne \t%a\n" 2+4
reg: NEGI1(reg) "\tneg \t%0\n" 2
reg: NEGI2(reg) "\tneg \t%0\n" 2
reg: NEGF1(reg) "\tneg \t%0\n" 2
reg: NEGF2(reg) "\tneg \t%0\n" 2
con1: CNSTI1 "%a" range(a,1,1)
reg: LSHI1(reg, rc) "\trep \t%1\n\tasl \t%0\n" 4+2
reg: LSHI1(reg, con1) "\tasl \t%0\n" 4
reg: LSHI2(reg, rc) "\trep \t%1\n\tasl \t%0\n" 4+2
reg: LSHI2(reg, con1) "\tasl \t%0\n" 4
reg: LSHU1(reg, rc) "\trep \t%1\n\tlsl \t%0\n" 4+2
reg: LSHU1(reg, con1) "\tlsl \t%0\n" 4
reg: LSHU2(reg, rc) "\trep \t%1\n\tasl \t%0\n" 4+2
reg: LSHU2(reg, con1) "\tasl \t%0\n" 4
reg: RSHI1(reg, rc) "\trep \t%1\n\tasr \t%0\n" 4+2
reg: RSHI1(reg, con1) "\tasr \t%0\n" 4
reg: RSHI2(reg, rc) "\trep \t%1\n\tasr \t%0\n" 4+2
reg: RSHI2(reg, con1) "\tasr \t%0\n" 4
reg: RSHU1(reg, rc) "\trep \t%1\n\tlsr \t%0\n" 4+2
reg: RSHU1(reg, con1) "\tlsr \t%0\n" 4
reg: RSHU2(reg, rc) "\tmove \t#0,%02\n\trep \t%1\n\tasr \t%0\n" 4+2
reg: RSHU2(reg, con1) "\tmove \t#0,%02\n\tasr \t%0\n" 4
reg: BANDI1(reg, reg) "\tand \t%0,%1\n" 2
reg: BANDI2(reg, reg) "# \tand \t%0,%1\n" 2
reg: BANDU1(reg, reg) "\tand \t%0,%1\n" 2
reg: BANDU2(reg, reg) "# \tand \t%0,%1\n" 2
reg: BORI1(reg, reg) "\tor \t%0,%1\n" 2
reg: BORI2(reg, reg) "# \tor \t%0,%1\n" 2
reg: BORU1(reg, reg) "\tor \t%0,%1\n" 2
reg: BORU2(reg, reg) "# \tor \t%0,%1\n" 2
reg: BXORI1(reg, reg) "\teor \t%0,%1\n" 2
reg: BXORI2(reg, reg) "# \teor \t%0,%1\n" 2
reg: BXORU1(reg, reg) "\teor \t%0,%1\n" 2
reg: BXORU2(reg, reg) "# \teor \t%0,%1\n" 2
reg: BCOMI1(reg) "\tnot \t%0\n" 2
reg: BCOMI2(reg) "# \tnot \t%0\n" 2
reg: BCOMU1(reg) "\tnot \t%0\n" 2
reg: BCOMU2(reg) "# \tnot \t%0\n" 2
%%
   static int equal(Node p, int a){
   if(p->syms[0]->u.c.v.i == a){
     return 0;
   } else {
     return LBURG_MAX;
   }
 }
   static void progbeg(int argc, char **argv) {
     int i, n;
     char section[256];
     time_t res = time(NULL);
     print(";;;; LCC-DSP56k - compiled on %s\n", asctime(localtime(&res)));
     parseflags(argc, argv);
     ireg[0] = mkreg("x0", 0, 1, IREG);
     ireg[1] = mkreg("x1", 1, 1, IREG);
     ireg[2] = mkreg("y0", 2, 1, IREG);
     ireg[3] = mkreg("y1", 3, 1, IREG);
     ireg2[0] = mkreg("x", 0, 1, IREG);
     ireg2[1] = mkreg("y", 2, 1, IREG);
     ireg2[0]->x.regnode->mask = 3; // 00000011
     ireg2[1]->x.regnode->mask = 12; // 00001100
     areg[0] = mkreg("a0", 4, 1, IREG);
     areg[1] = mkreg("a1", 5, 1, IREG);
     areg[2] = mkreg("b0", 6, 1, IREG);
     areg[3] = mkreg("b1", 7, 1, IREG);
     areg2[0] = mkreg("a", 4, 1, IREG);
     areg2[1] = mkreg("b", 6, 1, IREG);
     areg2[0]->x.regnode->mask = 48; // 00110000
     areg2[1]->x.regnode->mask = 192; // 11000000
     for(i = 0; i < 8; i++) {
       rreg[i] = mkreg(stringf("r%d", i), i+8, 1, IREG);
     }
     iregw = mkwildcard(ireg);
     ireg2w = mkwildcard(ireg2);
     aregw = mkwildcard(areg);
     areg2w = mkwildcard(areg2);
     rregw = mkwildcard(rreg);
     tmask[IREG] = 0x0000BEFF; // R7,5-1 Y,X Y1,Y0,X1,X0
     tmask[FREG] = 0x00000000;
     vmask[IREG] = 0x00000000;
     vmask[FREG] = 0x00000000;
     // convert . to _ and remove the path in filename
     // (../path/to/file.c -> file_c)
     if(firstfile) {
       for(i = n = 0; firstfile[i] && i < 255; i++){
	 char ch = firstfile[i] == '.' ? '_' : firstfile[i];
	 if(ch == '/') {
	   n = 0;
	 } else {
	   section[n++] = ch;
	 }
       }
       section[i]=0;
       print("\tsection %s\n", section);
     }
     // so - write symbols
     // nomd - do not write macro defs
     // rp - generate nop insn to accomodate pipeline delay
     print("\topt \tso,nomd,rp\n");
   }
static void progend(void) {
  print("\n\tendsec\n");
  print("\tend\n");
}
static Symbol rmap(int opk) {
  debug2(fprint(stderr, "Inside %s: %d\n", "rmap", opk));
  switch(optype(opk)) {
  case P: case B:
    return rregw;
    break;
  case I: case U: case F:
    if(opsize(opk) == 1) {
      return iregw;
    } else {
      return ireg2w;
    }
    break;
  default:
    return 0;
  }
}
static void segment(int n) {
  debug2(fprint(stderr, "Inside %s: %d\n", "segment", n));
  if(n == cseg) {
    return;
  }
  cseg = n;
  if(n == CODE){
    print("\torg p:\n");
  } else {
    print("\torg y:\n");
  }
}
static void target(Node p) {
  debug2(fprint(stderr, "Inside %s: %x\n", "target", p));
  switch(specific(p->op)) {
  case CALL+B:
    setreg(p, areg2[0]); //a
    //rtarget(p, 1, areg2[0]); //a
    break;
  case ADD+I: case SUB+I: case ADD+U: case SUB+U:
  case ADD+F: case SUB+F:
    setreg(p, areg2[0]); //a
    rtarget(p, 0, areg2[0]); //a
    break;
  case MUL+I: case MUL+U: case MUL+F:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, ireg[2]); //y0 This is bad but prevents this
      rtarget(p, 1, ireg[3]); //y1 error: a*b*c -> mpy y0,y1,b
      setreg(p, areg2[1]); //b mpy b,x1,b
    } else {
      rtarget(p, 0, areg2[0]); //a
      rtarget(p, 1, areg2[1]); //b
      setreg(p, areg2[1]); //b
    }
    break;
  case DIV+I: case DIV+U: case DIV+F:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, areg2[0]); //a
      rtarget(p, 1, ireg[0]); //x0
      setreg(p, areg2[0]); //a
    } else {
      rtarget(p, 0, areg2[0]); //a
      rtarget(p, 1, areg2[1]); //b
      setreg(p, areg2[0]); //a
    }
    break;
  case MOD+I: case MOD+U:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, areg2[0]); //a
      rtarget(p, 1, ireg[0]); //x0
      setreg(p, areg2[0]); //a
    } else {
      rtarget(p, 0, areg2[0]); //a
      rtarget(p, 1, areg2[1]); //b
      setreg(p, areg2[0]); //a
    }
    break;
  case LSH+I: case RSH+I: case LSH+U: case RSH+U:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, areg2[0]); //a
      setreg(p, areg[1]); //a1
    } else {
      rtarget(p, 0, areg2[0]); //a
      setreg(p, areg2[0]); //a1
    }
    break;
  case NEG+I: case NEG+F:
    rtarget(p, 0, areg2[0]); //a
    setreg(p, areg2[0]); //a
    break;
  case BAND+I: case BOR+I: case BAND+U: case BOR+U:
  case BXOR+I: case BXOR+U:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, ireg[3]); //y1
      rtarget(p, 1, areg[1]); //a1
      setreg(p, areg[1]); //a1
    } else {
      rtarget(p, 1, areg2[0]); //a
      setreg(p, areg2[0]); //a
    }
    break;
  case BCOM+I: case BCOM+U:
    if(opsize(p->op) == 1) {
      rtarget(p, 0, areg[1]); //a1
      setreg(p, areg[1]); //a1
    } else {
      rtarget(p, 0, areg2[0]); //a
      setreg(p, areg2[0]); //a
    }
    break;
  case EQ+I: case GE+I: case GT+I: case LE+I: case LT+I: case NE+I:
  case EQ+U: case GE+U: case GT+U: case LE+U: case LT+U: case NE+U:
  case EQ+F: case GE+F: case GT+F: case LE+F: case LT+F: case NE+F:
    rtarget(p, 0, areg2[0]); //a
    if(opsize(p->op) == 2) {
      rtarget(p, 1, areg2[1]); //b
    }
    break;
  case CALL+I: case CALL+U: case CALL+F: case CALL+P: case CALL+V:
    setreg(p, areg2[0]); //a
    break;
  case RET+I: case RET+U: case RET+F:
    rtarget(p, 0, areg2[0]); //a
    break;
  case RET+P:
    rtarget(p, 0, areg[1]); //a1
    break;
  case CVI+I: case CVI+U: case CVI+F: case CVU+I: case CVU+U:
  case CVF+I: case CVF+F:
    if(opsize(p->op) == 1){
      setreg(p, areg2[0]); //a
    } else {
      setreg(p, areg2[0]); //a
    }
    break;
  case LOAD+I: case LOAD+U: case LOAD+F:
    if(p->kids[0]->x.inst == _rreg_NT){
      break;
    }
    if(opsize(p->op) == 1){
      rtarget(p, 0, areg2[0]); //a
    } else {
      rtarget(p, 0, areg2[0]); //a
    }
    break;
  default:
    break;
  }
}
static void clobber(Node p) {
  debug2(fprint(stderr, "Inside %s: %x\n", "clobber", p));
  assert(p);
}
static char *reg_name(int reg){
  if(reg >= 0 && reg <= 3){
    return ireg[reg]->x.name;
  } else if(reg == 4 || reg == 6){
    return areg2[reg/2 - 2]->x.name;
  } else if(reg == 5 || reg == 7){
    return areg[reg - 4]->x.name;
  } else {
    assert(0);
  }
}
static void emit2(Node p) {
  debug2(fprint(stderr, "Inside %s: %x\n", "emit2", p));
  switch(specific(p->op)) {
  case CNST+F:
    assert(0);
    break;
  case CNST+I: case CNST+U: {
    assert(opsize(p->op) == 2);
    //reg: CNSTI2 "# \tmove \t%a,%c\n" 0
    int reg = getregnum(p);
    print("\tmove \t#>%d,%s\n",
	  (int)(p->syms[0]->u.c.v.i & 0xFFFFFF), reg_name(reg));
    print("\tmove \t#>%d,%s\n",
	  (int)(p->syms[0]->u.c.v.i >> 24), reg_name(reg + 1));
    break;
  }
  case INDIR+I: case INDIR+U: case INDIR+F: {
    if(p->kids[0]->op != VREG+P){
      if(opsize(p->op) == 2){
	int dst = getregnum(p);
	//reg: INDIRI2(addr) "\tmove \t%0,%c\n"
	print("\tmove \t");
	emitasm(p->kids[0], _addr_NT);
	if(p->kids[0]->x.inst == _rreg_NT){
	  print("+,%s\n", reg_name(dst));
	} else {
	  print(",%s\n", reg_name(dst));
	}
	print("\tmove \t");
	emitasm(p->kids[0], _addr_NT);
	if(p->kids[0]->x.inst == _rreg_NT){
	  print("-,%s\n", reg_name(dst + 1));
	} else {
	  print("+1,%s\n", reg_name(dst + 1));
	}
      }
    }
    break;
  }
  case ASGN+I: case ASGN+U: case ASGN+F: {
    if(p->kids[0]->op != VREG+P){
      if(opsize(p->op) == 2){
	int src = getregnum(p->kids[1]);
	//stmt: ASGNI2(addr, reg) "\tmove \t%1,%0\n"
	print("\tmove \t%s,", reg_name(src));
	emitasm(p->kids[0], _addr_NT);
	if(p->kids[0]->x.inst == _rreg_NT){
	  print("+\n");
	} else {
	  print("\n");
	}
	print("\tmove \t%s,", reg_name(src+1));
	emitasm(p->kids[0], _addr_NT);
	if(p->kids[0]->x.inst == _rreg_NT){
	  print("-\n");
	} else {
	  print("+1\n");
	}
      }
    }
    break;
  }
  case ASGN+B: {
    int src = getregnum(p->x.kids[1]) - 8;
    int dst = getregnum(p->x.kids[0]) - 8;
    int lab = genlabel(1);
    print("\tmove \tr%d,n%d x1,Y:(r6)\n", src, src);
    print("\tmove \tr%d,n%d\n", dst, dst);
    print("\tdo \t#%d,L%d\n", (int)p->syms[0]->u.c.v.i, lab);
    print("\tmove \tY:(r%d)+,x0\n", src);
    print("\tmove \tx0,Y:(r%d)+\n", dst);
    print("L%d:\n", lab);
    print("\tmove \tn%d,r%d\n", src, src);
    print("\tmove \tn%d,r%d Y:(r6),x1\n", dst, dst);
    break;
  }
  case ADD+P:
    //rreg: ADDP1(rreg, rc) "# \tmove \t%1,n8\n\tlua \t(%0)+n8,%c\n"
    //rreg: ADDP1(rc, rreg) "# \tmove \t%0,n8\n\tlua \t(%1)+n8,%c\n"
    if(p->kids[0]->x.inst == _rreg_NT){
      int reg = getregnum(p->x.kids[0]) - 8;
      int dst = getregnum(p) - 8;
      print("\tmove \t");
      emitasm(p->kids[1], _rc_NT);
      print(",n%d\n\tlua \t(r%d)+n%d,r%d\n", reg, reg, reg, dst);
    } else if(p->kids[1]->x.inst == _rreg_NT){
      int reg = getregnum(p->x.kids[1]) - 8;
      int dst = getregnum(p) - 8;
      print("\tmove \t");
      emitasm(p->kids[0], _rc_NT);
      print(",n%d\n\tlua \t(r%d)+n%d,r%d\n", reg, reg, reg, dst);
    } else
      assert(0);
    break;
  case SUB+P:
    //rreg: SUBP1(rc, rreg) "# \tmove \t%0,n8\n\tlua \t(%1)-n8,%c\n"
    //rreg: SUBP1(rreg, rc) "# \tmove \t%1,n8\n\tlua \t(%0)-n8,%c\n"
    if(p->kids[0]->x.inst == _rreg_NT){
      int reg = getregnum(p->x.kids[0]) - 8;
      int dst = getregnum(p) - 8;
      print("\tmove \t");
      emitasm(p->kids[1], _rc_NT);
      print(",n%d\n\tlua \t(r%d)-n%d,r%d\n", reg, reg, reg, dst);
    } else if(p->kids[1]->x.inst == _rreg_NT){
      int reg = getregnum(p->x.kids[1]) - 8;
      int dst = getregnum(p) - 8;
      print("\tmove \t");
      emitasm(p->kids[0], _rc_NT);
      print(",n%d\n\tlua \t(r%d)-n%d,r%d\n", reg, reg, reg, dst);
    } else
      assert(0);
    break;
  case MUL+I: case MUL+U: case MUL+F: {
    //reg: MULI1(reg, reg) "\tmpy \t%0,%1,%c\n\tasr \t%c\n
    // \tmove \t%c0,%c\n"
    if(opsize(p->op) == 1) {
      int s1 = getregnum(p->x.kids[0]);
      int s2 = getregnum(p->x.kids[1]);
      int d = getregnum(p);
      char *src1 = p->x.kids[0]->syms[RX]->x.name;
      char *src2 = p->x.kids[1]->syms[RX]->x.name;
      if(s1 == s2){
	//temp_reg = x1, x0 if x1 is taken
	char *temp_reg = (s1 == 0) ? (ireg[1]->x.name) : (ireg[0]->x.name);
	print("\tmove \t%s,Y:(r6)\n", temp_reg);
	print("\tmove \t%s,%s\n", src2, temp_reg);
	print("\tmpy \t%s,%s,%s\n",src1, temp_reg, p->syms[RX]->x.name);
	if(optype(p->op) == I || optype(p->op) == U){
	  print("\tasr \t%s\n", p->syms[RX]->x.name);
	  print("\tmove \t%s0,%s Y:(r6),%s\n", p->syms[RX]->x.name,
		p->syms[RX]->x.name, temp_reg);
	}
      } else {
	print("\tmpy \t%s,%s,%s\n",src1, src2, p->syms[RX]->x.name);
	if(optype(p->op) == I || optype(p->op) == U){
	  print("\tasr \t%s\n", p->syms[RX]->x.name);
	  print("\tmove \t%s0,%s\n", p->syms[RX]->x.name, p->syms[RX]->x.name);
	}
      }
    } else {
      // long mpy - copied from motorola
      // a and b is input regs and b is output reg
      int lab1 = genlabel(1);
      int lab2 = genlabel(1);
      if(optype(p->op) == F){
	warning("double multiply is not implemented; using long multiply instead\n");
      }
      print("\t;; begin long multiply\n");
      print("\tmoven0,y:(r6)+\n");
      print("\tmovea0,y:(r6)+\n");
      print("\tmovea1,y:(r6)+\n");
      print("\tmovex0,y:(r6)+\n");
      print("\tmovex1,y:(r6)+\n");
      print("\tmovey0,y:(r6)+\n");
      print("\tmove#$0,n0\n");
      print("\tmovea1,x0\n");
      print("\teorx0,bb1,x1\n");
      print("\tjplL%d\n", lab1);
      print("\tmove#$1,n0\n");
      print("L%d:\n", lab1);
      print("\tabsa x1,b1\n");
      print("\tabsb y1,y:(r6)+\n");
      print("\tmoveb0,y:(r6)+\n");
      print("\tmoveb1,y:(r6)\n");
      print("\tclrb b1,x0\n");
      print("\tmovex0,b0\n");
      print("\taslb\n");
      print("\taslb\n");
      print("\tclrb b1,x0\n");
      print("\tmovea1,b0\n");
      print("\taslb\n");
      print("\taslb #$7fffff,y1\n");
      print("\tmoveb1,x1\n");
      print("\tmovey:(r6)-,b\n");
      print("\tmovey:(r6),b0\n");
      print("\tmovex0,y:(r6)+\n");
      print("\tmovex1,y:(r6)\n");
      print("\taslb\n");
      print("\tandy1,b\n");
      print("\tmoveb1,x0\n");
      print("\tasrb\n");
      print("\tmoveb0,b\n");
      print("\tandy1,b\n");
      print("\tmoveb1,x1\n");
      print("\tasla\n");
      print("\tandy1,ay1,b1\n");
      print("\tmovea1,y0\n");
      print("\tasra\n");
      print("\tmovea0,y1\n");
      print("\tandy1,b\n");
      print("\tmoveb1,y1\n");
      print("\tmpyx1,y1,b\n");
      print("\tmpyx1,y0,a\n");
      print("\tmacx0,y1,a\n");
      print("\tmovea1,a2\n");
      print("\tmovea0,a1\n");
      print("\tmove#$0,a0\n");
      print("\tasra\n");
      print("\tadda,b\n");
      print("\tmpyx0,y0,a\n");
      print("\tmovey:(r6)-,y0\n");
      print("\tmovey:(r6)-,x0\n");
      print("\tmacy0,x1,a\n");
      print("\tmacx0,y1,a\n");
      print("\tclra a0,x0\n");
      print("\tmovex0,a2\n");
      print("\tasra y:(r6)-,y1\n");
      print("\tasra y:(r6)-,y0\n");
      print("\tadda,by:(r6)-,x1\n");
      print("\tasrb y:(r6)-,x0\n");
      print("\tmoven0,a\n");
      print("\ttsta y:(r6)-,a\n");
      print("\tjeqL%d\n", lab2);
      print("\tnegb\n");
      print("L%d:\n", lab2);
      print("\ttstb y:(r6)-,a0\n");
      print("\tmovey:(r6),n0\n");
      print("\t;; end long multiply\n");
    }
    break;
  }
  case DIV+I: case DIV+U: case DIV+F:{
    if(opsize(p->op) == 1){
      char *src = ireg[getregnum(p->x.kids[1])]->x.name;
      char *dst = p->syms[RX]->x.name;
      int lab = genlabel(1);
      print("\tmove \tb,Y:(r6)+\n");
      print("\tabs \t%s %s,b\n", dst, dst); //b
      if(optype(p->op) == I || optype(p->op) == U){
	print("\tclr \t%s %s1,Y:(r6)\n", dst, dst);
	print("\tmove \tY:(r6),%s0\n", dst);
	print("\tasl \t%s\n", dst);
      }
      print("\trep \t#24\n");
      print("\tdiv \t%s,%s\n", src, dst);
      print("\teor \t%s,b\n", src); //b
      print("\tjpl \tL%d\n", lab);
      print("\tneg \t%s\n", dst);
      print("L%d:\tmove \t%s0,%s\n", lab, dst, dst);
      print("\tmove \tY:-(r6),b\n");
    } else {
      // long div - copied from motorola
      // a and b is input regs and a is output reg
      int lab[11];
      int i;
      for(i = 0; i < 11; i++){
	lab[i] = genlabel(1);
      }
      if(optype(p->op) == F){
	warning("double division is not implemented; using long division instead\n");
      }
      print("\t;;-- begin long division\n");
      print("move n0,y:(r6)+\n");
      print("move b0,y:(r6)+\n");
      print("move b1,y:(r6)+\n");
      print("move x0,y:(r6)+\n");
      print("move x1,y:(r6)+\n");
      print("move y0,y:(r6)+\n");
      print("move y1,y:(r6)+\n");
      print("\n");
      print("move #$0,n0\n");
      print("move b1,y1\n");
      print("eor y1,a a1,y0\n");
      print("jpl L%d\n", lab[2]);
      print("move #$1,n0\n");
      print("L%d:\n", lab[2]);
      print("abs b y0,a1\n");
      print("abs a #$0,x1\n");
      print("\n");
      print("move b1,y1\n");
      print("clr b b0,y0\n");
      print("move b1,y:(r6)\n");
      print("\n");
      print("ori #$04,mr\n");
      print("asl a #>$1,x0\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[3]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[3]);
      print("andi #$f3,mr\n");
      print("div x1,b\n");
      print("\n");
      print("do #$2f,L%d\n", lab[4]);
      print("btst #23,y:(r6)\n");
      print("jcs L%d\n", lab[5]);
      print("add x,a\n");
      print("move #$0,a2\n");
      print("ori #$04,mr\n");
      print("asl a\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[6]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[6]);
      print("andi #$f3,mr\n");
      print("div x1,b\n");
      print("sub y,b\n");
      print("jmp L%d\n", lab[7]);
      print("L%d:\n", lab[5]);
      print("move #$0,a2\n");
      print("ori #$04,mr\n");
      print("asl a\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[8]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[8]);
      print("andi #$f3,mr\n");
      print("div x1,b\n");
      print("add y,b\n");
      print("L%d:\n", lab[7]);
      print("move a1,x1\n");
      print("move b1,a1\n");
      print("eor y1,a\n");
      print("move b1,y:(r6)\n");
      print("move x1,a1\n");
      print("move #$0,x1\n");
      print("L%d:\n", lab[4]);
      print("btst #23,y:(r6)\n");
      print("jcs L%d\n", lab[9]);
      print("add x,a\n");
      print("L%d:\n", lab[9]);
      print("move #$80,x1\n");
      print("eor x1,a (r6)-\n");
      print("move #$0,a2\n");
      print("\n");
      print("move n0,b\n");
      print("tst b\n");
      print("jeq L%d\n", lab[10]);
      print("neg a\n");
      print("L%d:\n", lab[10]);
      print("move y:(r6)-,y1\n");
      print("move y:(r6)-,y0\n");
      print("move y:(r6)-,x1\n");
      print("move y:(r6)-,x0\n");
      print("move y:(r6)-,b\n");
      print("tst a y:(r6)-,b0\n");
      print("move y:(r6),n0\n");
      print("\t;;-- end long division\n");
    }
    break;
  }
  case MOD+I: case MOD+U: {
    if(opsize(p->op) == 1){
      char *src = ireg[getregnum(p->x.kids[1])]->x.name;
      char *dst = p->syms[RX]->x.name;
      int lab = genlabel(1);
      print("\tmove \tb,Y:(r6)+\n");
      print("\tabs \t%s %s,b\n", dst, dst); //b
      print("\tclr \t%s %s1,Y:(r6)\n", dst, dst);
      print("\tmove \tY:(r6),%s0\n", dst);
      print("\tasl \t%s\n", dst);
      print("\trep \t#24\n");
      print("\tdiv \t%s,%s\n", src, dst);
      print("\tmove \t%s1,Y:(r6)\n", dst);
      print("\tmove \t%s,%s\n", src, dst);
      print("\tabs \t%s Y:(r6),%s\n", dst, src);//destroy x0 (src)
      print("\tadd \t%s,a\n", src);
      print("\tasr \t%s\n", dst);
      print("\ttst \tb\n"); //b
      print("\tjge \tL%d\n", lab);
      print("\tneg \t%s\n", dst);
      print("L%d:\n", lab);
      print("\tmove \tY:-(r6),b\n");
    } else {
      // long modulo - copied from motorola
      // a and b is input regs and b is output reg
      int lab[14];
      int i;
      for(i = 0; i < 14; i++){
	lab[i] = genlabel(1);
      }
      print("\t;;-- begin long modulo\n");
      print("move n0,y:(r6)+\n");
      print("move b0,y:(r6)+\n");
      print("move b1,y:(r6)+\n");
      print("move x0,y:(r6)+\n");
      print("move x1,y:(r6)+\n");
      print("move y0,y:(r6)+\n");
      print("move y1,y:(r6)+\n");
      print("move r0,y:(r6)+\n");
      print("move r1,y:(r6)+\n");
      print("move #$0,n0\n");
      print("tst a\n");
      print("jpl L%d\n", lab[12]);
      print("abs a\n");
      print("move #$1,n0\n");
      print("L%d:\n", lab[12]);
      print("move b1,y1\n");
      print("tfr a,b b0,y0\n");
      print("\n");
      print("clr a #>$1,x0\n");
      print("tst b #$0,x1\n");
      print("jpl L%d\n", lab[1]);
      print("sub x,a\n");
      print("L%d:\n", lab[1]);
      print("move b1,x1\n");
      print("move a1,b1\n");
      print("eor y1,b r6,r0\n");
      print("move b1,y:(r6)+\n");
      print("move r6,r1\n");
      print("move b1,y:(r6)+\n");
      print("move x1,b1\n");
      print("move #$0,b2\n");
      print("ori #$04,mr\n");
      print("asl b #$0,x1\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[2]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[2]);
      print("andi #$f3,mr\n");
      print("div x1,a\n");
      print("\n");
      print("do #$2f,L%d\n", lab[3]);
      print("btst #23,y:(r1)\n");
      print("jcs L%d\n", lab[4]);
      print("add x,b\n");
      print("move #$0,b2\n");
      print("ori #$04,mr\n");
      print("asl b\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[5]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[5]);
      print("andi #$f3,mr\n");
      print("div x1,a\n");
      print("sub y,a\n");
      print("jmp L%d\n", lab[6]);
      print("L%d:\n", lab[4]);
      print("move #$0,b2\n");
      print("ori #$04,mr\n");
      print("asl b\n");
      print("andi #$fe,ccr\n");
      print("jec L%d\n", lab[7]);
      print("ori #$01,ccr\n");
      print("L%d:\n", lab[7]);
      print("andi #$f3,mr\n");
      print("div x1,a\n");
      print("add y,a\n");
      print("L%d:\n", lab[6]);
      print("move b1,x1\n");
      print("move a1,b1\n");
      print("eor y1,b\n");
      print("move b1,y:(r1)\n");
      print("move x1,b1\n");
      print("move #$0,x1\n");
      print("L%d:\n", lab[3]);
      print("btst #23,y:(r1)\n");
      print("jcs L%d\n", lab[8]);
      print("add x,b\n");
      print("L%d\n", lab[8]);
      print("move #$80,x1\n");
      print("eor x1,b\n");
      print("move #$0,x1\n");
      print("btst #23,y:(r0)\n");
      print("jcc L%d\n", lab[9]);
      print("add x,b\n");
      print("L%d:\n", lab[9]);
      print("move b1,x1\n");
      print("move y:(r0),b1\n");
      print("move y:(r1),x0\n");
      print("eor x0,b\n");
      print("move x1,b1\n");
      print("jpl L%d\n", lab[10]);
      print("btst #23,y:(r0)\n");
      print("jcc L%d\n", lab[11]);
      print("sub y,a\n");
      print("jmp L%d\n", lab[10]);
      print("L%d:\n", lab[11]);
      print("add y,a\n");
      print("L%d:\n", lab[10]);
      print("move n0,b\n");
      print("tst b\n");
      print("jeq L%d\n", lab[13]);
      print("neg a\n");
      print("L%d:\n", lab[13]);
      print("move (r6)-\n");
      print("move (r6)-\n");
      print("move (r6)-\n");
      print("move y:(r6)-,r1\n");
      print("move y:(r6)-,r0\n");
      print("move y:(r6)-,y1\n");
      print("move y:(r6)-,y0\n");
      print("move y:(r6)-,x1\n");
      print("move y:(r6)-,x0\n");
      print("move y:(r6)-,b\n");
      print("tst a y:(r6)-,b0\n");
      print("move y:(r6),n0\n");
      print("\t;;-- end long modulo\n");
    }
    break;
  }
  case ARG+I: case ARG+U: case ARG+F:{
    if(opsize(p->op) == 2){
      int src = getregnum(p->x.kids[0]);
      //stmt: ARGI2(reg) "# \tmove \t%0,Y:(r6)+\n"
      print("\tmove \t%s,Y:(r6)+\n", reg_name(src));
      print("\tmove \t%s,Y:(r6)+\n", reg_name(src + 1));
    }
    break;
  }
  case ARG+B: {
    int src = getregnum(p->x.kids[0]) - 8;
    int label = genlabel(1);
    int size = p->syms[0]->u.c.v.i;
    print("\tmove \t#%d,n6\n", size);
    print("\tmove \tr%d,n%d\n", src, src);
    print("\tmove \tx0,Y:(r6+n6)\n");
    if(size > 1) {
      print("\tdo \t#%d,L%d\n", size , label);
    }
    print("\tmove \tY:(r%d)+,x0\n", src);
    print("\tmove \tx0,Y:(r6)+\n");
    if(size > 1) {
      print("L%d:\n", label);
    }
    print("\tmove \tn%d,r%d\n", src, src);
    print("\tmove \tY:(r6),x0\n");
    break;
  }
  case BAND+I: case BAND+U:
  case BOR+I: case BOR+U:
  case BXOR+I: case BXOR+U: {
    //reg: BANDI2(reg, reg) "\tand \t%0,%1\n"
    int src = getregnum(p->x.kids[0]);
    int dst = getregnum(p->x.kids[1]);
    print("\tand \t%s,", reg_name(src + 1));
    emitasm(p->kids[1], _reg_NT);
    print("\t%s,Y:(r6)\n", reg_name(dst));
    print("\tmove \t%s,%s\n", reg_name(dst + 1), reg_name(dst));
    print("\tmove \tY:(r6),%s\n", reg_name(dst + 1));
    switch(generic(p->op)){
    case BAND:
      print("\tand \t%s,", reg_name(src));
      break;
    case BOR:
      print("\tor \t%s,", reg_name(src));
      break;
    case BXOR:
      print("\teor \t%s,", reg_name(src));
      break;
    }
    emitasm(p->kids[1], _reg_NT);
    print("\n\tmove \t%s,Y:(r6)\n", reg_name(dst + 1));
    print("\tmove \t%s,", reg_name(dst));
    emitasm(p->kids[1], _reg_NT);
    print("\n\tmove \tY:(r6),%s\n", reg_name(dst));
    break;
  }
  case BCOM+I: case BCOM+U: {
    //reg: BCOMI2(reg) "\tnot \t%0\n"
    int src = getregnum(p->x.kids[0]);
    print("\tnot \t%s\n", reg_name(src + 1));
    print("\tmove \t%s,Y:(r6)\n", reg_name(src + 1));
    print("\tmove \t%s,%s\n", reg_name(src), reg_name(src + 1));
    print("\tnot \t%s\n", reg_name(src + 1));
    print("\tmove \t%s,%s\n", reg_name(src + 1), reg_name(src));
    print("\tmove \tY:(r6),%s\n", reg_name(src + 1));
    break;
  }
  case RET+I: case RET+U: case RET+F:
    break;
  case CVI+I: case CVI+U: case CVI+F: case CVU+I: case CVU+U:
  case CVF+I: case CVF+F: {
    char *src = p->kids[0]->syms[RX]->x.name;
    char *dst = p->syms[RX]->x.name;
    if(src == areg2[1]->x.name){
      print("\ttfr \t%s,%s\n", src, dst);
    } else {
      print("\tmove \t%s,%s\n", src, dst);
    }
    break;
  }
  case LOAD+I: case LOAD+U: case LOAD+F:
    assert(opsize(p->op) == 2);
    if(opsize(p->x.kids[0]->op) == 2){
      int src = getregnum(p->x.kids[0]);
      int dst = getregnum(p);
      print("\tmove \t%s,%s\n", reg_name(src), reg_name(dst));
      print("\tmove \t%s,%s\n", reg_name(src+1), reg_name(dst+1));
    } else {
      print("\tmove \t%s,%s\n", p->kids[0]->syms[RX]->x.name, p->syms[RX]->x.name);
      assert(0);
    }
    break;
  default:
    break;
  }
}
static void doarg(Node p) {
  debug2(fprint(stderr, "Inside %s: %x\n", "doarg", p));
  mkactual(1, p->syms[0]->u.c.v.i);
}
static void blkfetch(int k, int off, int reg, int tmp) {
  debug2(fprint(stderr, "Inside %s\n", "blkfetch"));
}
static void blkstore(int k, int off, int reg, int tmp) {
  debug2(fprint(stderr, "Inside %s\n", "blkstore"));
}
static void blkloop(int dreg, int doff, int sreg, int soff,
		    int size, int tmps[]) {
  debug2(fprint(stderr, "Inside %s\n", "blkloop"));
}
static void local(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s, retstruct: %d\n", "local", p->name, retstruct));
  if (retstruct) {
    assert(p == retv);
    p->sclass = REGISTER;
    if(askregvar(p, rreg[7]) == 0) {
      assert(0);
    }
    retstruct = -1;
    return;
  }
  if(askregvar(p, rmap(ttob(p->type))) == 0) {
    mkauto(p);
  }
}
static void function(Symbol f, Symbol caller[], Symbol callee[], int n) {
  int i;
  debug2(fprint(stderr,"Inside %s: %s, %d\n", "function", f->name, n));
  usedmask[0] = usedmask[1] = 0;
  freemask[0] = freemask[1] = ~(unsigned)0;
  offset = -3;
  for(i = 0; callee[i]; i++) {
    Symbol p = callee[i];
    Symbol q = caller[i];
    assert(q);
    if(q->type->size == 2) { //long, double
      p->x.offset = q->x.offset = offset - 1;
      p->x.name = q->x.name = stringf("%d", offset - 1);
    } else { //char, short, int, float
      p->x.offset = q->x.offset = offset;
      p->x.name = q->x.name = stringf("%d", offset);
    }
    p->sclass = q->sclass = AUTO;
    offset -= q->type->size;
  }
  assert(caller[i] == 0);
  offset = maxoffset = 0;
  retstruct = isstruct(freturn(f->type));
  debug2(fprint(stderr, "gencode(%s):\n", f->name));
  gencode(caller, callee);
  print("\n ;;;; Function %s starts\n", f->name);
  print("\tglobal\t%s\n", f->x.name);
  print("%s:\n", f->x.name);
  print("\tmove \tr0,Y:(r6)+ \t;; save frame pointer\n");
  print("\tlua \t(r6)+,r0 \t;; set new frame pointer\n");
  print("\tmove \tssh,Y:(r6)+ \t;; save return address\n");
  debug2(fprint(stderr, "usedmask[IREG]: %x, usedmask[FREG]: %x\n",
		usedmask[IREG], usedmask[FREG]));
  for(i = 0; i < 4; i++) {
    if(usedmask[IREG] & (1 << i)) {
      print("\tmove \t%s,Y:(r6)+ \t;; save ireg\n",
	    ireg[i]->x.name);
    }
  }
  for(i = 6; i < 8; i++) {
    if(usedmask[IREG] & (1 << i)) {
      print("\tmove \t%s,Y:(r6)+ \t;; save areg\n",
	    areg[i-4]->x.name);
    }
  }
  for(i = 8; i < 16; i++) {
    if(usedmask[IREG] & (1 << i)) {
      print("\tmove \t%s,Y:(r6)+ \t;; save rreg\n",
	    rreg[i-8]->x.name);
    }
  }
  debug2(fprint(stderr, "offset: %d, maxoffset: %d, argoffset: %d, maxargoffset: %d\n", offset, maxoffset,
		argoffset, maxargoffset));
  if(maxoffset > 0) {
    print("\tmove \t#%d,n6 \t\t;; update stack with local and temp offset\n", maxoffset);
    print("\tmove \t(r6)+n6 \t;;\n");
  }
  if(retstruct == -1){
    print("\tmove \ta,r7\n");
    retstruct = 0;
  }
  debug2(fprint(stderr, "emitcode(%s):\n", f->name));
  emitcode();
  if(maxoffset > 0) {
    print("\tmove \t#%d,n6 \t\t;; restore stack\n", maxoffset);
    print("\tmove \t(r6)-n6 \t;;\n");
  }
  for(i = 15; i >= 8; i--) {
    if(usedmask[IREG] & (1 << i)) {
      print("\tmove \tY:-(r6),%s \t;; restore rreg\n",
	    rreg[i-8]->x.name);
    }
  }
  if(usedmask[IREG] & (1 << 7)) { //FIX b1.b0 ->b.b0
    print("\tmove \t%Y:-(r6),%s \t;; restore areg\n",
	  areg2[1]->x.name);
  }
  if(usedmask[IREG] & (1 << 6)) {
    print("\tmove \t%Y:-(r6),%s \t;; restore areg\n",
	  areg[2]->x.name);
  }
  for(i = 3; i >= 0; i--) {
    if(usedmask[IREG] & (1 << i)) {
      print("\tmove \t%Y:-(r6),%s \t;; restore ireg\n",
	    ireg[i]->x.name);
    }
  }
  print("\tmove \tY:-(r6),ssh \t;; restore return address\n");
  print("\ttst \ta Y:-(r6),r0 \t;; restore frame pointer and test a\n");
  print("\trts \n");
  print(" ;;;; Function %s ends\n\n", f->name);
}
static void defsymbol(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s -> ", "defsymbol", p->name));
  if(p->scope >= LOCAL && p->sclass == STATIC) {
    p->x.name = stringf("F__%s%d", cfunc->name, genlabel(1));
  } else if(p->generated) {
    p->x.name = stringf("L%s", p->name);
  } else if(p->scope == CONSTANTS
	    && (isint(p->type) || isptr(p->type))) {
    if(p->name[0] == '0' && p->name[1] == 'x') {
      p->x.name = stringf("$%s", &p->name[2]);
    } else {
      p->x.name = p->name;
    }
  } else {
    p->x.name = stringf("F%s", p->name);
  }
  debug2(fprint(stderr, "%s\n", p->x.name));
}
static void address(Symbol q, Symbol p, long n) {
  debug2(fprint(stderr, "Inside %s: %s, %s, %d\n", "address", q->name, p->name, n));
  if (p->scope == GLOBAL || p->sclass == STATIC || p->sclass == EXTERN)
    q->x.name = stringf("%s%s%D", p->x.name, n >= 0 ? "+" : "", n);
  else {
    assert(n <= INT_MAX && n >= INT_MIN);
    q->x.offset = p->x.offset + n;
    q->x.name = stringd(q->x.offset);
  }
}
static void defconst(int suffix, int size, Value v) {
  debug2(fprint(stderr, "Inside %s: %d, %d, %d \n", "defconst", suffix, size, v.i));
  if (suffix == F) {
    if(size == 1) {
      unsigned u;
      if(v.d == 1.0){
	u = 0x7FFFFF;
      } else {
	u = (unsigned)(v.d * 8388608) & 0xFFFFFF;
      }
      print("\tdc\t$%x\n", u);
    } else {
      long long u;
      if(v.d == 1.0){
	u = 0x7FFFFFFFFFFFLL;
      } else {
	u = (long long)(v.d * 16777216*8388608) & 0xFFFFFFFFFFFFLL;
      }
      print("\tdc\t$%x\n", (unsigned)(u & 0xFFFFFF));
      print("\tdc\t$%x\n", (unsigned)(u >> 24));
    }
  } else if (suffix == P) {
    print("\tdc\t$%x\n", (unsigned)v.p);
  } else if (size == 1) {
    print("\tdc\t$%x\n", (unsigned)(suffix == I ? v.i : v.u));
  } else if (size == 2) {
    print("\tdc\t$%x\n", (unsigned long)((suffix == I ? v.i : v.u) & 0xFFFFFF));
    print("\tdc\t$%x\n", (unsigned long)((suffix == I ? v.i : v.u) >> 24));
  }
}
static void defaddress(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s\n", "defaddress", p->name));
  print("\tdc\t%s\n", p->x.name);
}
static void defstring(int n, char *str) {
  int i;
  debug2(fprint(stderr, "Inside %s: ", "defstring"));
  if(n == -1){
    print("\tdc\t%d\n", *(int *)str);
  } else {
    for(i = 0; i < n; i++) {
      debug2(fprint(stderr, "%d - %c, ", str[i], str[i]));
      print("\tdc\t%d\n", str[i]);
    }
  }
  debug2(fprint(stderr, ", %d\n", n));
}
static void export(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s\n", "export", p->name));
}
static void import(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s\n", "import", p->name));
}
static void global(Symbol p) {
  debug2(fprint(stderr, "Inside %s: %s\n", "global", p->name));
  print("\tglobal\t%s\n%s\n", p->x.name, p->x.name);
}
static void space(int n) {
  debug2(fprint(stderr, "Inside %s: %d\n", "space", n));
  print("\tbsc\t%d\n", n);
}
Interface dsp56kIR = {
  1, 1, 0, /* char */
  1, 1, 0, /* short */
  1, 1, 0, /* int */
  2, 2, 0, /* long */
  2, 2, 0, /* long long */
  1, 1, 1, /* float */
  2, 2, 1, /* double */
  2, 2, 1, /* long double */
  1, 1, 0, /* T * */
  0, 1, 0, /* struct */
  1, /* little_endian */
  0, /* mulops_calls */
  1, /* wants_callb */
  1, /* wants_argb */
  0, /* left_to_right */
  0, /* wants_dag */
  0, /* unsigned_char */
  address,
  blockbeg,
  blockend,
  defaddress,
  defconst,
  defstring,
  defsymbol,
  emit,
  export,
  function,
  gen,
  global,
  import,
  local,
  progbeg,
  progend,
  segment,
  space,
  0, 0, 0, 0, 0, 0, 0,
  {
    1, /* max_unaligned_load */
    rmap,
    blkfetch, blkstore, blkloop,
    _label,
    _rule,
    _nts,
    _kids,
    _string,
    _templates,
    _isinstruction,
    _ntname,
    emit2,
    doarg,
    target,
    clobber,
  }
};
static char rcsid[] = "$Id: dsp56k.md,v 1.24 2004/08/19 13:42:43 henan702 Exp $";
